#pragma once

#include "reckoner.h"
#include "line_tracker.h"
#include "logger.h"

void loadCalibration();

void waitForSignalToStart();
void findLineAndCalibrate(); void findLine();  // two alternatives
void turnRightToFindLine();
void followLineToEnd();
void driveHomeAlmost();
void finalSettleIn();
void __attribute__((noreturn)) loggerReportLoop();

void updateMotorsToFollowLine();
void updateReckonerFromEncoders();
void setLeds(bool v1, bool v2, bool v3, bool v4);
float determinant();
float dotProduct();
float magnitude();
void loggerService();

extern Reckoner reckoner;
extern LineTracker lineTracker;
extern Logger logger;